(function() {
	'use strict';

	angular.module('ipconfigure.orchid').controller('LoginCtrl', ['$scope', '$rootScope', 'AuthService', 'FocusOnService', LoginCtrl]);

	function LoginCtrl($scope, $rootScope, AuthService, FocusOnService) {
		$scope.username = '';
		$scope.password = '';
		$scope.failure = '';
		$scope.remember = false;
		$scope.processing = false;

		FocusOnService('initial-field');

		$scope.logIn = function() {
			if (!$scope.password) {
				$scope.failure = 'Please enter a password.';
				FocusOnService('password-field');
			}
			else {
				$scope.processing = true;

				AuthService.authenticateViaCredentials($scope.username, $scope.password, $scope.remember)
					.then(function() {
						// tell the AppCtrl that the user logged in
						$rootScope.$broadcast('logIn');
					})
					.catch(function(response) {
						// if the login was unsuccessful, let the user know
						$scope.processing = false;

						if (typeof response !== 'object') {
							$scope.failure = 'An unexpected error occurred.';
						}
						else {
							$scope.failure = response.code + ': ' + response.reason;
						}

						FocusOnService('initial-field');
					});
			}
		};

		$scope.toggleCompatibilityMode = function() {
			$rootScope.compatibilityMode = !$rootScope.compatibilityMode;
			localStorage.compatibilityMode = $rootScope.compatibilityMode;
		};
	}
}());
