(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('cameraListSizer', [cameraListSizer]);

	function cameraListSizer() {
		function setSize(element) {
			var visibleSections;

			if (document.body.clientWidth < 992) {
				element.style.height = '120px';
			}
			else {
				visibleSections = document.querySelectorAll('.admin-nav > li:not(.ng-hide)').length;

				element.style.height = 'calc(100vh - 69px - ' + (visibleSections * 49) + 'px + 5px)';
			}
		}

		return {
			restrict: 'A',
			link: function(scope, wrappedElement) {
				var element = wrappedElement[0],
					sizerDelay;

				setSize(element);

				window.addEventListener('resize', function() {
					clearTimeout(sizerDelay);

					sizerDelay = setTimeout(function() {
						setSize(element);
					}, 333);
				});
			}
		};
	}
}());
