(function() {
	'use strict';

	angular.module('ipconfigure.orchid.directive').directive('triggerShake', ['$timeout', triggerShake]);

	function triggerShake($timeout) {
		return {
			restrict: 'A',
			link: function(scope, wrappedElement, attrs) {
				scope.$watch(attrs.triggerShake, function(value) {
					if (value > 0) {
						var element = wrappedElement[0];

						// MS EDGE hack
						element.style.animation = '';

						element.classList.add('shake');
						element.classList.add('shake-constant');
						element.classList.add('shake-horizontal');

						$timeout(function() {
							element.classList.remove('shake');
							element.classList.remove('shake-constant');
							element.classList.remove('shake-horizontal');

							// MS EDGE hack
							element.style.animation = 'none';
						}, 250);
					}
				});
			}
		};
	}
}());
