(function() {
	'use strict';

	angular.module('ipconfigure.orchid.filter').filter('objectToArray', [objectToArrayFilter]);

	function objectToArrayFilter() {
		return function(obj, objectsOnly) {
			var arr,
				key;

			if (!(obj instanceof Object)) {
				return obj;
			}

			arr = [];

			for (key in obj) {
				if (obj.hasOwnProperty(key) === true && (!objectsOnly || (objectsOnly && typeof obj[key] === 'object'))) {
					arr.push({
						key: key,
						value: obj[key]
					});
				}
			}

			return arr;
		};
	}
}());
