(function() {
	'use strict';

	var mod = angular.module('ipconfigure.orchid', ['ipconfigure.orchid.core', 'ipconfigure.orchid.directive', 'ipconfigure.orchid.filter', 'ipconfigure.orchid.service', 'ngAnimate', 'ui.bootstrap']);

//	mod.value('BaseServiceUrl', 'http://' + location.host + '/orchid-service-mock/orchid-instance2.js');
	mod.value('BaseServiceUrl', location.protocol + '//' + location.host);

	mod.config(['$animateProvider', '$compileProvider', '$httpProvider', '$logProvider', function($animateProvider, $compileProvider, $httpProvider, $logProvider) {
		// don't try to animate elements with fa-spin
		$animateProvider.classNameFilter(/^((?!(fa-spin)).)*$/);

		// register our error handler
		$httpProvider.interceptors.push('HttpResponseErrorHandler');

		// initialize get if not there
		if (!$httpProvider.defaults.headers.get) {
			$httpProvider.defaults.headers.get = {};
		}

		// disable IE ajax request caching
		$httpProvider.defaults.headers.get.Pragma = 'no-cache';
		$httpProvider.defaults.headers.get['Cache-Control'] = 'no-cache';

		// allow CORS
		$httpProvider.defaults.withCredentials = true;

		// turn on debug logging on/off
		$logProvider.debugEnabled(false);

		// support hrefs
		$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|rtsp|data):/);

		// required fbgst version (using window for ipc-components)
		window.requiredFbgstVersion = '1.3.0';
	}]);
}());
