(function() {
	'use strict';

	angular.module('ipconfigure.orchid.service').factory('PlayerComponentRegistrar', ['NativeTypeGenerator', 'TimeDeltaService', PlayerComponentRegistrar]);

	function PlayerComponentRegistrar(NativeTypeGenerator, TimeDeltaService) {
		var _registeredComponents = NativeTypeGenerator.generateArray(),
			_currentTime = 0;

		return {
			registerComponent: function(playerScope, timeline, video) {
				_registeredComponents.push({
					playerScope: playerScope,
					timeline: timeline,
					video: video
				});
			},
			unregisterComponent: function(playerId) {
				_registeredComponents.some(function(components, index) {
					if (parseInt(components.playerScope.playerId, 10) === playerId) {
						_registeredComponents.splice(index, 1);
						return true;
					}
				});
			},
			getComponents: function() {
				return _registeredComponents;
			},
			getComponentsByPlayerId: function(playerId) {
				var i;

				for (i = 0; i < _registeredComponents.length; i++) {
					if (_registeredComponents[i].playerScope.playerId === playerId) {
						return {
							playerScope: _registeredComponents[i].playerScope,
							timeline: _registeredComponents[i].timeline,
							video: _registeredComponents[i].video
						};
					}
				}

				return null;
			},
			getTime: function() {
				return _currentTime;
			},
			setTime: function(time) {
				_currentTime = time;
			},
			getTimeDifference: function() {
				return TimeDeltaService.getDifference();
			}
		};
	}
}());
